/***************************/
/*  Simulation de BILLARD  */
/*      en  MEGAMAX C      */
/*    vers 1.2  23/11/86   */
/*      Stphane BUTEL     */
/* HEBDOGICIEL n165 a 168. */
/***************************/
/* Note de saisie:         */
/* Cette version en mode   */
/* texte et une saisie     */
/* qui n'a pas ete testee, */
/* compilee ou corrigee.   */
/*                         */
/* Si vous reussisez a     */
/* compiler ce programme,  */
/* merci de bien vouloir   */
/* nous envoyer l'image    */
/* disquette du programme. */
/*                         */
/* L'equipe d'             */
/* Hebdogiciel,les listings*/
/*                         */
/* www.hebdogiciel.free.fr */
/* nov. 2016   Marsupilami.*/
/***************************/
#include <stdio.h>
#include <gemdefs.h>
#include <obdefs.h>
#include <osbind.h>
/* Si vous possedez le fichier define.h
tapez :
#include <define.h>
sinon tapez :
#define TRUE -1
#define FALSE 0
*/
#define TRUE -1
#define FALSE 0
/****** messages ******/
int ret,msgbuff[8];
extern int gl_apid;
/****** graphiques ********/
int contrl[12];
int intin [128];
int ptsin [128];
int intout[128];
int ptsout[128];
int handle,wi_handle,work_in[11],work_out[57];
int phys_handle,key,button;
int gi_hchar,gl_wchar,gl_wbox,gl_hbox;
int xdesk,ydesk,wdesk,hdesk;
int mx,my; /** souris **/
int pxy[8];
/* arbre objet feuille dialogue */
#define CANCEL 8 /*OBJECT in TREE#O*/
#define OK 9 /*OBJECT in TREE#O*/
char *rs_strings[] = {
"00","Rayon des boules : __","99",
"MODIFICATION DES PARAMETRES",
"90","[oef de rebond : 0.__","99",
"30","Frottement sur bandes : 0.__","99",
"05","Frottement glissement : 0.__","99",
"005","Frottement roulement : 0.___","999",
"010","Masse des boules  : __._","999",
"INITIAL"," OK "};

TEDINFO rs_tedinfo[] = {
0L, 1L, 2L, 3, 6, 0, 0xl180, 0x0, -1, 3, 27,
4L, 5L, 6L, 3, 6, 0, 0xl180, 0x0, -1, 3, 29,
7L, 8L, 9L, 3, 6, 0, 0xl180, 0x0, -1, 3, 29,
}0L, 11L, 12L, 3, 6, 0, 0xl180, 0x0, -1, 3,29,
}3L, 14L, 15L, 3, 6, 0, 0xl180, 0x0, -1, 4,30,
}6L, 17L, 18L, 3, 6, 0, 0xl180, 0x0, -1, 4,29};

OBJECT rs_object[] = {
-1, 1, 9, G_BOX, NONE, OUTLINED, 0x21100L, 0, 0, 280,12,
2, -1, -1, G_FTEXT, EDITABLE, NORMAL, 0x0L, 24, 3, 208,1,
3, -1, -1, G_STRING, NONE, OUTLINED, 0x3L, 32, 1, 216,1,
4, -1, -1, G_FTEXT, EDITABLE, NORMAL, 0x5L, 24, 4, 224,1,
5, -1, -1, G_FTEXT, EDITABLE, NORMAL, 0xlL, 24, 5, 224,1,
6, -1, -1, G_FTEXT, EDITABLE, NORMAL, 0x2L, 24, 6, 224,1,
7, -1, -1, G_FTEXT, EDITABLE, NORMAL, 0x3L, 24, 7, 224,1,
8, -1, -1, G_FTEXT, EDITABLE, NORMAL, 0x4L, 24, 8, 232,1,
9, -1, -1, G_BUTTON, 0x5, NORMAL, 0xl3L, 48, 10, 64,1,
0, -1, -1, G_BUTTON, 0x27, NORMAL, 0xl4L, 152,10, 64,1};

#define NUM_OBS 10
char toc [] = { 2,100,3,9,11,100,12,2,13,9,7,236,6,5,9,26,255,0};
/* variables du programme */
int njoueur = 1; /* nbre joueurs */
int cjoueur = 0; /* joueur actif */
int yreso,xreso; /* resol. en y et x */
int xopt; /* x des options a l'ecran */
int teta; /* direction mvt */
int lq; /* longueur queue */
int xq,yq; /* pt queue-boule */
int fxq,fyq; /* pt extremite queue */
int tx0,ty0; /* origine tapis haut gauche */
int rl; /* rayon boule loupe */
int r; /* rayon des boules */
double fcoup=0.0; /* force coup */
int xb[3],yb[3]; /* pos centre boules */
double v[3]; /* vitesse pt contact */
double vgx[3],vgy[3]; /* vitess c d g des boules */
double ux[3],uy[3]; /* vit du pt contact tapis */
double ox[3],oy[3],oz[3]; /* vecteur rotation instantane */
double g; /* accel pesanteur */
double fb; /* coef frott bandes */
double f; /* coef frottement glissement*/
double cr; /* coef restitution (rebon) */
double fr; /* coef frottement roulement*/
double m; /* masse des boules */
int x0[3],y0[3]; /* pos initiale boules*/
double t1[3]; /* duree mvt en cours */
double t; /* temps courant depuis debut*/
double dt; /* intervalle temps pour dessin */
double t0[3]; /* origine tmps derniere traj */
double tt; /* tps depuis dernier chang traj */
double dx,dy,dz; /* bras de levier choc*/
int mvt[3]; /* drapeau mvt en cours */
int fl,fin,fc,nb; /* drapeau divers */
long ecran,ecran2; /* 2 ecrans->flip */
FDB scr,scr2; /* fdb de ces ecrans */
int xcps; /* pos affich nbre coups */
int xpts; /* pos affich nbre pts */
int ncps[2],npts[2]; /* nbre coups et pts */
int chc; /* drapeau choc(calcul pts) */
int forcx; /* pos x curseur force */
int xl,yl; /* coord impact ds boule loupe */
int ycl,xcl; /* coord centre boule loupe*/
int lx,ly; /* taille billard */
double vmx[3],vmy[3]; /* vit pt contact*/
char txt[24];
double sgrt(),sin(),cos();
long phys,logiq,sve_alc,PhysSave; /* pages ecran */
/*----------------*/
/* initialisation */
/*----------------*/
open_vwork()
{
int i;
for (i=0;i<10;work_in[i++]=1);
work_in[10] = 2;
handle = phys_handle;
v_opnvwk(work_in,&handle,work_out);
}

/*--------------*/
/* efface ecran */
/*--------------*/
cls(x,y,w,h)
int x,y,w,h;
{
int temp[4];
temp[0]=x; temp[1]=y;
temp[2]=x+w-1; temp[3]=y+h-1;
v_bar(handle,temp);
}

/****************/
/*  PROGRAMME   */
/****************/
main()
int event;

gl_apid = appl_init();
phys_handle = graf_handle(&gl_wchar,&gl_hchar,&gl_wbox,&gl_hbox);
wind_get(0,WF_WORKXYWH,&xdesk,&ydesk,&wdesk,&hdesk);
open_vwork();
yreso = work_out[1]+1;
xreso = work_out[0]+1;
xcl = xreso/2;
lx = (3*xcl)/2; ly = yreso/2;
set_col(); /* init couleurs */
scr_mem(); /* alloc. memoire */
arbre_init(); /* init arbre objets */
defaut() ; /* valeur param defaut */
sprintf(rs_strings[0],"%02d",r);
ycl = rl + gl_hchar;
depart();
new();
while(fin != TRUE)
{ event = evnt_multi((MU_KEYBDIMU_BUTTONIMU_M1|MU_M2),1,1,3,
0,xcl-rl,gl_hchar,2*rl,2*rl,
0,xopt,gl_hchar,120,3*gl_hchar,
msgbuff,0,0,&mx,&my,&button,&ret,&key,&ret);

if((event & MU_BUTTON) && button == 1)
{ if (inside(mx,my,fxq-5,fyq-5, 10, 10) )angle();
else if(inside(mx,my,xb[cjoueur]-r,yb[cjoueur]-r,2*r,2*r) )effet ();
else if(inside(mx,my,tx0+lx,ty0+ly,10,10))taille();
else force();
}
if((event & MU_BUTTON) && button == 3)
	{ queue(fxq,fyq,rq,yq);
copy_haut();
move();
raz_param ();
score();
graf_mouse(257,0);
}
if(event & MU_M1) loupe();
if((event & MU_M2) && !inside(mx,my,fxq-5,fyq-5,10,gl_hchar+4))
options();

if(event & MU_KEYBD)
{ switch (key) {
case 0x3920 : /* space bar */
queue(fxq,fyq,xq,yq);
copy_haut();
move();
raz_param();
score();
graf_mouse(257,0);
break;
case 0x011B : /* escape */
ret=form_alert(1,"[3][Autre partie ou Quitter ][AUTRE|QUIT]");
if(ret == 2) fin = TRUE;
else new();
break;
} /* fin switch key */
} /* fin if keybd */
} /* fin while false */
Setscreen(PhysSave,PhysSave,-1);
Mfree(sve_alc);
v_clsvwk(handle);
appl_exit();
}

/*-----------------*/
/* nouvelle partie */
/*-----------------*/
new()
{
graf_mouse(256,0);
decor();
jeu_init(); /* init le jeu */
vswr_mode(handle,3);
vsm_color(handle,1);
pxy[0]=xl; pxy[1]=yl;
v_pmarker(handle,1,pxy);
vswr_mode (handle,1);
npts[0]=0; npts[1]=0; ncps[0]=0; ncps[1]=0;
njoueur = 1; cjoueur = 0;
raz_param();
fin = FALSE;
graf_mouse(5,0);
sve_screen(&scr,&scr2);
graf_mouse(257,0);
}

/*--------*/
/* SCORES */
/*--------*/
score()
{
if (xreso>500) sprintf (txt, "%3d%3d  ",ncps[0],ncps[1]);
else sprintf (txt," %3d %3d ",ncps[0],ncps[1]);
v_gtext(handle,xcps,2*gl_hchar,txt);
if(xreso >500) sprintf (txt, "%3d%3d ",npts[0],npts[1]);
else sprintf(txt," %3d %3d ",npts[0],npts[1]);
v_gtext(handle,xcps,3*gl_hchar,txt);
}

/*----------------------------*/
/*copy haut ecran->logic ecran*/
/*----------------------------*/
copy_haut ()
{
graf_mouse (256, 0);
pxy[0] = 0; pxy[1] = 0; pxy[2] = xreso ; pxy[3] = yreso/5;
pxy[4] = 0; pxy[5] = 0; pxy[6] = xreso ; pxy[7] = pxy[3];
vro_cpyfm (handle, 3, pxy, &scr, &scr2) ;
gr lf _mouse ( 257, 0) ;
}
/*-----------------------*/
/* mouvemt ecran complet */
/*-----------------------*/
sve_screen(sce,dest)
FDB *sce,*dest;
{
pxy[0]=0; pxy[1]=0; pxy[2]=xreso; pxy[3] = yreso;
pxy[4]=pxy[0]; pxy[5]=pxy[1]; pxy[6]=pxy[2]; pxy[7]=pxy[3];
vro_cpyfm(handle,3,pxy,sce,dest);
}

/*-----------------------*/
/*initialise arbre objets*/
/*-----------------------*/
arbre_init()
{ int i,j;
for (i=0;i<NUM_OBS;i++)
{ rs_object[i].ob_y *= gl_hchar; rs_object[i] ob_height *= gl_hchar;
switch (rs_object[i].ob_type){
case G STRING :
rs_object[i].ob_spec = (char*)(rs_strings[3]);
break;
case G_BUTTON :
rs_object[i].ob_spec = (char*)(rs_strings[11+i]);
break;
case G FTEXT :
rs_object[i].ob_spec =
(char*) (&rs_tedinfo[(int)rs_object[i].ob_spec]);
break;
} /* fin switch */
} /* fin for */

for (i=0;i<6;i++)
{ j = (int)rs_tedinfo[i].te_ptext;

rs_tedinfo[i].te_ptext = (char*)(rs_strings[j]);
rs_tedinfo[i].te_ptmplt = (char*)(rs_strings[j+1]);
rs_tedinfo[i].te_pvalid = (char*)(rs_strings[j+2]);
}
}

/*-----------------------*/
/* allocation mem ecrans */
/*-----------------------*/
scr_mem ()
{
long tp;
ecran2 = Malloc(0x8100L);
sve_alc = ecran2;
tp = ecran2 & 0xFFL;
tp = -tp;
tp &= 0xFFL;
ecran2 += tp; /* ici adresse ecran est bien sur multiple 256 */
if(yreso == 400) scr.fd_nplanes = 1;
else if (xreso >500)scr.fd_nplanes = 2;
else scr.fd_nplanes = 4;
scr.fd_addr = 0L; scr.fd_w = xreso;
scr.fd_h = yreso; scr.fd_wdwidth = (scr.fd_w >> 4);
scr.fd_stand = 0;
scr2.fd_addr = ecran2; scr2.fd_w = scr.fd_w;
sr_r2.fd_h = scr.fd_h; scr2.fd_wdwidth = scr.fd_wdwidth;
scr2.fd_stand = 0;
srr2.fd_nplanes = scr.fd_nplanes;
phys = PhysSave = Physbase(); logiq = ecran2;
}

/*----------------------*/
/* etablit les couleurs */
/*----------------------*/
set_col ()
{
int rgb[3];
rgb[0]=1000; rgb[1]=1000; rgb[2]=1000;
vs_color(handle,0,rgb);
rgb[0]=750; rgb[1]=0; rgb[2]=450;
vs_color(handle,l,rgb);
rgb[0]=900; rgb[1]=0; rgb[2]=0;
vs_color(handle,2,rgb);
rgb[0]=0; rgb[1]=500; rgb[2]=0;
vs_color(handle,3,rgb);
}

/*-----------------------*/
/* parametres par defaut */
/*-----------------------*/
defaut()
{
if( xreso > 500)
{ r = 10; rl = 30; lq = 50; )
else
{ r = 6; rl = 18; lq = 25; )
g = 9.81; m = 1.0;
fb = 0.3; f = 0.05;
cr = 0.9; fr = 0.005;
dt = 0.5;
}

/*-- au depart prog ---*/
depart()
{
tx0 = 50; ty0 = yreso/5 + 22;
xl = xcl; yl = ycl;
dz = 0.0; dx = 0.0; dy = 0.0;
forcx = 35;
npts[0] = 0; npts[1] = 0;
ncps[0] = 0; ncps[1] = 0;
}

/*----------------------*/
/* initialisation ecran */
/*----------------------*/
jeu_init()
{
int i;
xb[0] = tx0 + lx/3; yb[0] = ty0 + ly/2
xb[1] = tx0 + 2*lx/3; yb[1] = ty0 + ly/3;
xb[2] = tx0 + 2*lx/3; yb[2] = ty0 + 2*ly/3;
boules();
}

/*------------*/
/* les boules */
/*------------*/
boules()
{
vsf_color (handle,0) ;
v_circle(handle,xb[0],yb[0],r);
v_circle(handle,xb[1],yb[1],r);
vsf_color(handle,2);
if (yreso > 200)
{ vsf_interior(handle,2);
vsf_style (handle,2);
}
v_circle(handle,xb[2],yb[2],r);
vsf_interior(handle,1);
}

/*----------------------*/
/* R.A.Z des parametres */
/*----------------------*/

raz_param ( )
{
int k;
for (k = 0; k<3;k++)
{ vmx[k]=0.0; vmy[k]=0.0;
vgx[k]=0.0; vgy[k]=0.0;
mvt[k] = 0; v[k]=0.0;
ox[k]=0.0; oy[k]=0.0; oz[k]=0.0;
ux[k]=0.0; uy[k]=0.0;
t0[k]=0.0; t1[k]=0.0;
x0[k] = xb[k]; y0[k] = yb[k];
}
chc = 0; fc = 0;
teta = 180; xq=xb[cjoueur]-r-1;
fxg=xq-lq; yg=yb[cjoueur]; fyg=yb[cjoueur];
ux[cjoueur] = -1.0;
vgx[cjoueur] = fcoup;
queue(fxq,fyq,xq,yq);
vswr_mode(handle,3);
pxy[0]=xl; pxy[1]=yl;
v_pmarker(handle,1,pxy);
xl=xcl; pxy[0]=xl; pxy[1]=y1;
v_pmarker(handle,1,pxy);
vswr_mode(handle,1);
}

/*--------------------*/
/* dessin de la queue */
/*--------------------*/
queue(x1,y1,x2,y2)
int x1,y1,x2,y2;
{
vswr_mode(handle,3);
vsl_color(handle,0);
vsl_width(handle,3);
pxy[0] = x1; pxy[1] = y1; pxy[2] = x2; pxy[3] = y2;
v_pline(handle,2,p,xy);
vswr_mode (handle, 10 ;
vsl_width(handle,1);
}

/*---------------------*/
/* direction mouvement */
/*---------------------*/
angle()
{
int x,y,tp;
double angl;
tp = teta;
graf_mouse(256,0);
button = 0;
while( button != 2) /* bouton droit pour sortir */
{ x = mx ; y = my;
graf_mkstate(&mx,&my,&button,&ret);
if(x  != mx && (fyq > (yq+30) || fyq <(yq-30)) && button != 2)
{ if(my < yb[cjoueur]) tp = x-mx + teta;
else tp = mx-x + teta;
}
else if(y != my && button != 2)
{ if(mx < xb[cjoueur]) tp = my-y+teta;
else tp = y-my+teta;
}
if(tp > 360) tp -= 360;
else if (tp < 0) tp += 360;
if(tp != teta)
{ angl = tp*3.14159/180.0;
x = xcl-rl*((xg-xb[cjoueur])*sin(angl)+(yq-yb[cjoueur])*cos(angl))/r;
if (x < (xcl+rl) && x > (xcl-rl))
{teta = tp;
queue(fxq,fyq,xq,yq);
fxq = xq + lq * cos(angl);
fyq = yq - lq * sin(angl);
queue (fxq, fyq, xq, yq) ;
dx = (xcl-x)*r*sin(angl)/rl;
dy = (xcl-x)*r*cos(angl)/rl;
vswr_mode(handle,3); /* mode XOR */
pxy[0] = xl; pxy[1] = yl; /* efface anc position */
v_pmarker(handle,1,pxy); /* marque boule loupe */
pxy[0]= x; pxy[1] = yl;
v_pmarker(handle,1,pxy); /* place nouvelle */
vswr_mode(handle,1);/* mode AND */
xl = x;
}
}
} /* fin while */
vsin_mode(handle,1,2);
vsm_locator (handle,fxq,fyq,&ret,&ret,&ret);
graf_mkstate(&mx,&my,&button,&ret);
ux[cjoueur] = cos(teta*3.14159/180.0);
uy[cjoueur] = sin(teta*3.14159/180.0);

vgx[cjoueur]= -fcoup*ux[cjoueur];
vgy[cjoueur]=  fcoup*uy[cjoueur];
graf_mouse(257,0);
}

/*----------------------------*/
/* choix effet de boule loupe */
/*----------------------------*/
loupe()
{
int xt,yt;
int event;
double tpangl,x1,y1;
event = 0;
while(!(event & MU_M1))
{ event = evnt_multi((MU BUTTON|MU_M1),1,1,1,1,xcl-rl-2,gl_hchar,2*rl+2,2*rl+2,0,0,0,0,0,msgbuff,0,0,&mx,&my,&button,&ret,&key,&ret);
if(event & MU_BUTTON)
{ graf_mouse(256,0);
xt = xcl-mx;
yt = my-ycl;
if (xt*xt+yt*yt < rl*rl)
{ vswr_mode(handle,3); /*mode XOR*/
pxy[0] = xl; pxy[1] = yl; /* efface anc position */
v_pmarker(handle,1,pxy);
pxy[0]=mx; pxy[1] = my;
v_pmarker(handle,1,pxy); /* place nouve i n */
vswr_mode(handle,1) ; /* mode AND */
xl = mx; yl = my; /* memo dans xl et yl*/
xl = xt*r/rl;
yl = (-sgrt (r*r-xl*xl));
tpangl = teta*3.14159/180.0;
dy = xl*cos(tpangl);
dz _ (yt*r/rl) ;
dx = xl*sin (tpangl) ;
queue(fxq,fyq,xq,yq);
xq = xb[cjoueur]+xl*sin(tpangl)-yl*cos(tpangl); /* coord dans */
yq = yb[cjoueur]+xl*cos(tpangl)+yl*sin(tpangl); /* repere fixe*/
fxq = xq + lq*cos (tpangl); /* matrice:cos sin: */
fyq = yq - lq*sin(tpangl); /* rot inv:-sin cos: */
queue(fxq,fyq,xq,yq); /* angle : teta-pi/2*/
}
graf mouse(257,0);
}
} /* fin while */
}

/*------------------*/
/* choix de l'effet */
/*------------------*/
effet()
{
int xt,yt;
double xl,tpangl;
double gm; /* dist exacte centre pt contact queue boule */
double l;
graf_mouse(256,0);
xt = mx-xb[cjoueur]; yt = my-yb[cjoueur]; /* coord ds repere fixe */
l = xt*xt + yt*yt;
if (l > (r*r+15.0) || l == 0) { graf_mouse(257,0); return;}
if(xt*(xq-xb[cjoueur]) <= 0 || yt*(yq-yb[cjoueur]) <= 0)
{ if(yt < -r/2) teta = 90;
else if( yt > r/2 ) teta = 270;
else if (xt<0)teta = 180;
else teta = 0;
}
gm = sgrt((double)r*r-dz*dz);
tpangl = teta * 3.14159/180.0;
queue(fxq,fyq,xq,yq);
xl = (xt*sin(tpangl) + yt*cos(tpangl))*gm/r;
l = r * xt / sgrt(l);
xq = xb[cjoueur] + l;
if(yt > 0)yq = yb[cjoueur] + sgrt(r*r-l*l);
else yq = yb[cjoueur] - sgrt(r*r-l*l);
fxq = xq + lq*cos(tpangl);
fyq = yq - lq*sin(tpangl);
queue (fxq,fyq,xq,yq);
dx = xl * sin(tpangl);
dy = xl * cos(tpangl);
vswr_mode(handle,3);
pxy[0] = xl; pxy[1] =yl;
v_pmarker(handle,1,pxy);
xl = xcl - xl*rl/r;
pxy[0] = xl; pxy[1]=yl;
v_pmarker(handle,1,pxy);
vswr_mode(handle,1);
ux[cjoueur] = cos(tpangl);
uy[cjoueur] = sin(tpangl);
vgx[cjoueur]= -fcoup*ux[cjoueur];
vgy[cjoueur]=  fcoup*uy[cjoueur];
graf_mouse(257,0);
}

/*---------------*/
/* force du coup */
/*---------------*/
force()
{
button = 1;
graf_mouse(256,0);
vsl_color (handle,2); vsl_width (handle,4);
pxy[0] = 34; pxy[1]= 4*gl_hchar+4; pxy[3] = pxy[1];
while(button == 1)
{ graf_mkstate(&mx,&my,&button,&ret);
if(forcx < (xcl-rl)) forcx += 2;
else
{ vswr_mode(handle,3);
v_pline(handle,2,pxy);
vswr_mode (handle,1) ;
forcx = 35;
}
pxy[2] = forcx;
v_pline(handle,2,pxy);
}
graf_mouse(257,0);
vsl_width(handle,1);
fcoup = (forcx - 34.0)/10.0;
vgx[cjoueur] = -fcoup * ux[cjoueur];
vgy[cjoueur] =  fcoup * uy[cjoueur];
}

/*-------------------*/
/* taille du billard */
/*-------------------*/
taille()
{
int i;
int oldw,oldh;
oldw = lx; oldh = ly;
graf_rubberbox (tx0,ty0,100,80,&lx,&ly);
graf_mouse(256,0);
if (lx > (xreso-lq-tx0)) lx = xreso-lq-tx0;
if (ly > (yreso-lq-ty0)) ly = yreso-lq-ty0;
billard(lx,ly);
if( lx<oldw || ly<oldh)

{ vsf_style(handle,2);
vsf_interior(handle,2);
vsf_color (handle,1);
if(lx<oldw) cls(tx0+1x+16,ty0-16,oldw-lx+1,oldh+33);
if(ly<oldh) cls(tx0-16,ty0+ly+16,oldw+33,oldh-ly+2);
vsf_interior (handle,1);
}

jeu_init();
sve_screen(&scr,&scr2);
raz_param();
graf_mouse(257,0);
}

/*--------*/
/* INSIDE */
/*--------*/
inside(x,y,ax,ay,aw,ah )
int x,y,ax,ay,aw,ah;
{
if ((x>= ax) && (y >= ay) && (x<ax+aw) && (y<ay+ah))
return(TRUE);
else
return(FALSE);
}

/*---------*/
/* options */
/*---------*/
options()
{ int event;
graf_mouse(ARROW,0);
event = 0;
while(!(event & MU_M1))
{ event = evnt_multi((MU_BUTTONIMU_M1),1,1,1,1,xopt,gl_hchar,140,4*gl_hchar,0,0,0,0,0,msgbuff,0,0,&mx,&my,&button,&ret,&key,&ret);
graf_mouse(256,0);
if((event & MU_BUTTON)&& inside(mx,my,xopt,gl_hchar,100,gl_hchar))
{ if (njoueur == 1)
{ njoueur = 2;
v_gtext(handle,xopt,2*gl_hchar," 2 JOUEURS ");
}
else
{ njoueur = 1;
v_gtext(handle,xopt,2*gl_hchar," 1 JOUEUR  ");
}
}
if((event & MU_BUTTON) && inside(mx,my,xopt,3*gl_hchar,80,gl_hchar))
{ sve_screen(&scr,&scr2);
hndl_dial();
sve_screen(&scr2,&scr);
}
if((event & MU_BUTTON) && inside(mx,my,xopt+88,3*gl_hchar,40,gl_hchar))
{ event = MU_M1;
ret = form_alert(1,"[3][Autre partie ou Quitter ][AUTRE|QUIT]");
if (ret == 2) fin = TRUE;
else new();
}
graf_mouse (257,0);
} /* fin while */
graf_mouse (5,0);
/*------------------*/
/* feuille dialogue */
/*------------------*/
hndl_dial ()
{
int xdial,ydial,wdial,hdial;
int exit_obj,oldr,i;
int rr;
double atof();
oldr = r;
form_center(&rs_object[0],&xdial,&ydial,&wdial,&hdial);
form_dial(0,1,1,1,1,xdial,ydial,wdial,hdial);
objc_draw(&rs_object[0],0,12,xdial,ydial,wdial,hdial);
graf_mouse(257,0);
exit_obj = form_do(&rs_object[0],0);
graf_mouse(256,0);
form_dial(3,1,1,1,1,xdial,ydial,wdial,hdial);
if(exit_obj == CANCEL)
{ defaut();
anc();
objc_change(&rs_object[0],CANCEL,0,xdial,ydial,wdial,hdial,NORMAL,0);
}
else
{ r = atoi(rs_strings[0]); txt[0]= '0'; txt[1]='.';
strcpy(&txt[2],rs_strings[4]); cr = atof (txt);
strcpy(&txt[2],rs_strings[7]); fb = atof (txt);
strcpy(&txt[2],rs_strings[10]);f  = atof (txt);
strcpy(&txt[2],rs_strings(13]);fr = atof (txt);
strcpy(&txt[1],rs_strings[16]);

txt[0]=txt[1]; txt[1]=txt[2]; txt[2]='.'; m = atof(txt);
objc_change(&rs_object[0],OK,0,xdial,ydial,wdial,hdial,NORMAL,0);
if(r < 1 || m < 0.1 || cr<0.01 || fb<0.01 || f<0.01 ||fr<0.001)
{ form _alert(1,"[3][pas de valeur(s) nulle(s) !|rien n'est retenu][OK]");
defaut ( ) ;
anc();
}
}
if (r != oldr )
{ if( r > oldr)
{ for(i=0;i<3;i++)
{ if (xb[i]+r > tx0+lx ) rr = tx0+lx-xb[i];
else if(xb[i]-r < tx0) rr = xb[i]-tx0;
if(yb[i]+r > ty0+ly) rr = ty0+ly-yb[i];

else if(yb[i]-r < ty0) rr = yb[i]-ty0;
if (r > ly/4-2) rr = ly/4-2;
}
}
if (rr < r || r < 6)
{ if (r < 6) r = 6;
else r = rr;
sprintf(rs_strings[0],"%02d",r);
form_alert(1,"[3][ |le rayon a ete modifie |restons raisonnables !...][ OK ]");
}
Setscreen(logiq,-1L,-1);
vsf_color(handle,3);

cls(tx0,ty0,lx,ly);
boules();
teta = 180; ux[cjoueur]= -1.0; uy[cjoueur] = 0.0;
vgx[cjoueur] = fcoup; vgy[cjoueur] = 0.0;
xq = xb[cjoueur]-r;
yq = yb[cjoueur];
fxq = xq - lq + 1;
fyq = yq;
queue(fxq,fyq,xq,yq);
Setscreen(phys,-1L,-1);
vswr_mode(handle,3);
pxy[0] = xl; pxy[1] = yl;
v_pmarker(handle,1,pxy);
xl = xcl; pxy[0] = xl; pxy[1]=y1;
v_pmarker(handle,1,pxy);
vswr_mode(handle,1);
}
}

/*------------------------------*/
/*reprend les anciennes valeurs */
/*------------------------------*/
anc()
{
int i;
sprintf(rs_strings[0],"%02d",r);
sprintf(txt,"%4.2f",cr); strcpy(rs_strings[4],&txt[2]);
sprintf(txt,"%4.2f",fb); strcpy(rs_strings[7],&txt[2]);
sprintf(txt,"%4.2f",f);  strcpy(rs_strings[10],&txt[2]);
sprintf(txt,"%5.3f",fr); strcpy(rs_strings[13],&txt[2]);
sprintf(txt,"%04.1f",m); txt[2]=txt[1]; txt[1]=txt[0];
strcpy(rs_strings[16],&txt[1]);
}

overlay "seg2"
/*-----------*/
/* mouvement */
/*-----------*/
move()
{ int k;

if(vgx[cjoueur]+vgy[cjoueur] != 0.0) mvt[cjoueur] = 3;
t = 0.0; fl = 1; dt = 8.0/fcoup;

if (dt > 0.6) dt = 0.6;
ox[cjoueur] =  2.5*dz*vgy[cjoueur]/(r*r*m); /* J x omega = moment */
oy[cjoueur] = -2.5*dz*vgx[cjoueur]/(r*r*m); /* de la percussion */
oz[cjoueur] =  2.5*(dx*vgy[cjoueur]-dy*vgx[cjoueur])/(r*r*m);
/* et J = 2/5 m r2 */
graf_mouse (256, 0);
Setscreen(logiq,-1L,-1); /* travail sur ecran logique */
ncps[cjoueur]++;/* un coup de plus */
nb = 0;
while(fl == 1)
{ t += dt;
fl = 0;/*1 si boule bouge encore*/
ret = 0; /* 1 si choc boules */
vsf_color(handle,3) ;
cls(tx0,ty0,lx,ly); /* efface la page logique */
for (k = 0; k < 3; k++)
{ if(mvt[k] != 0) /* si boule en mouvement */
{ fl = 1;
if(t >= t1[k] || mvt[k] == 3) calc_traj(k);
tt = t-t0[k];
if(mvt[k]==1) pos_gliss(k); /* nouvelle pos cas mouv glissment */
else if (mvt[k]==2)pos_roul(k); /* cas sans glissement */
test_choc(k);
} /* fin if mvt[k] */
vsf _color (handle,0) ;
if (k == 2)
{ vsf_color(handle,2);
if(yreso > 300) {vsf_interior(handle,2); vsf_style(handle,2);}
}
v_circle(handle,xb[k],yb[k],r);
vsf_interior(handle,1);
} /* fin for k */

if(ret) Dosound(toc);
flip_page(); /* echange page logique et physique */
if (dt < 0.6) dt += 0.0002;
} /* fin while */

Setscreen(phys,phys,-1);
scr2.fd_addr = logiq;
if (chc == 3)
npts[cjoueur]++;
else if(njoueur == 2)
{ cjoueur ^= 1;
if (cjoueur == 1)
{if (xreso>500) v_gtext(handle,xcps,gl_hchar," SCORE 2 ");
else v_gtext(handle,xcps,gl_hchar,"SCORE 2");
}
else
{if (xreso>500) v_gtext(handle,xcps,gl_hchar," SCORE 1 ");
else v_gtext (handle, xcps, gl_hchar, "SCORE 1");
}
}
vsin_mode(handle,1,2); /* histoire de ne pas chercher */
vss_locator (handle,xb[cjoueur],yb[cjoueur],&ret,&ret,&ret); /* la souris*/
}

/*-----------------------*/
/* calcul de trajectoire */
/*-----------------------*/

calc_traj (k)
int k;
{
switch(mvt[k]){
case 1 :
vgx[k] = vgx[k] - g*f*(t1[k]-t0[k])*ux[k];
vgy[k] = vgy[k] - g*f*(t1[k]-t0[k])*uy[k];
non_gliss(k);
break;
case 2 :
mvt[k] = 0; /* arret boule  k */
break;
case 3 :
gliss[k];
break;
}/* Fin  switch */
}

/*-----------------------*/
/* mouvt sans glissement */
/*-----------------------*/
non_gliss(k)
int k;
{
mvt[k] = 2;
v[k] = sgrt(vgx[k]*vgx[k]+vgy[k]*vgy[k]);
if(v[k] > 0.0001)
{ ux [k] = vgx[k]/v[k];
uy[k] = vgy[k]/v[k];
}
t0[k] = t-dt;
t1[k] = t0[k] + v[k]/(fr*r);
x0[k] = xb[k];
Y0[k] = yb[k];
}

/*-----------------------*/
/* mouvt avec glissement */
/*-----------------------*/

gliss(k)
int k;
{
mvt[k] = 1;
vmx[k] = vgx[k]-r*oy[k];
vmy[k] = vgy[k]+r*ox[k];

v[k] = sqrt(vmx[k]*vmx[k]+vmy[k]*vmy[k]);
if (v[k] < 0.001) non_gliss();
else
{ t0[k] =  t-dt;
t1[k] = t0[k] + (2.0*v[k]/(7.0*g*f));
ux[k] = vmx[k]/v[k];
uy[k] = vmy[k]/v[k];
x0[k] = xb[k];
y0[k] = yb[k];
}
}

/*----------------------------*/
/* calcul pos. cas glissement */
/*----------------------------*/
pos_gliss(k)
int k;
{
double tmp;
tmp = vgx[k]*tt - g*f*tt*ux[k]/2.0;
xb[k] = x0[k] + tmp;
tmp =  vgy[k]*tt - g*f*tt*tt*uy[k]/2.0;
yb[k] = y0[k] + tmp;
}

/*--------------------------*/
/* pos. cas sans glissement */
/*--------------------------*/
pos_roul(k)
int k;
{
double tmp;
tmp = vgx[k]*tt - fr*r*tt*ux[k]/2.0;
xb[k] = x0[k] + tmp;
tmp = vgy[k)*tt - fr*r*tt*tt*uy[k]/2.0;
yb[k] = y0[k] + tmp;
}

/*--------------------------*/
/* test des chocs possibles */
/* -------------------------*/
test_choc (k)
int k;
{
int i;
int deltax,deltay;
int drap;
int tempx,tempy;
drap = 0;
if (xb[k]< (tx0+r) && fc != 1)
{ drap = 1;
xb[k] = tx0+r;
g_rebon(k); /* rebond bande gauche */
}
else if (xb[k] > (tx0+lx-1-r) && fc != 2)
{ drap = 1;
xb[k] = tx0+1x-1-r;
d_rebon (k); /* rebond bande droites*/
else if (yb[k] < (ty0+r-1) && fc != 3)
{ drap = 1;
yb[k] = ty0 + r - 1;
h_rebon (k); /* rebond bande haute */
}
else if (yb[k] > (ty0+ly-r) && fc!= 4) < drap = 1;
yb[k] = ty0 + ly - r;

b_rebon (k) ; /* rebond bande basse */
}
else
{ for (i=0;i<3;i++); /* sinon test choc boules */
{ if (i != k)
{ if (fc != (4+i+k) && inside(xb[k],yb[k],xb[i]-2*r,yb[i]-2*r+1,4*r,4*r-1))
{ deltax = xb[k]-xb[i];
  deltay = yb[k]-yb[i];
if( (double)deltax*daltax + (double)deltay*deltay < 4.0*(double)r*r)
{ drap = 1;
ret = 1 ;
tempy = (int) sqrt(4.0*(double)r*r-deltax*deltax);
tempx = (int) sqrt(4.0*(double)r*r-deltay*deltay);

if( deltax >= 0 && deltay < 0)
{
if( vgy[k] > 0.0 && yb[i] > ty0+tempy+r)

yb[k]= yb[i] - tempy;
else xb[k] = xb[i] + tempx;
}
else if( deltax > 0 && deltay >= 0)
{ if (vgx[k] < 0.0 && xb[i]<(tx0+lx-r-tempx))
xb[k] = xb[i] + tempx;
else yb[k] = yb[i] + tempy;
}
else if( deltax < 0 && deltay < 0)
{if (vgy[k] <= 0.0 && xb[i] > tx0+tempx+r)
xb[k] = xb[i] - tempx;
else yb[k] = yb[i] - tempy;
}
else
{ if( vgx[k] > 0.0 && xb[i] > tx0+tempx+r)
xb[k] = xb[i] - tempx;
else yb[k] = yb[i] + tempy;
}

choc(k,i);
i = 3;
}
} /* fin if inside */
} /* fin if != k */
}/* fin for*/
} /* fin else */
if (drap == 1) /* param nouvelle traj en cas choc */
calc_traj (k) ; /* si non RAZ du drapeau*/
else if (fc < 5) fc = 0; /* qui evite les tests consecutifs avec */
else if ((++nb) == 6) /* les memes acte tirs (les situations */
{ fc = 0; nb = 0;} /* n'ayant pas encore evoluees a la 2e boucle */
} /* ou la nb ieme cas entre boules */


/*-----------------------*/
/* affiche page logique  */
/*-----------------------*/
flip-page()
{
long temp;
temp = logiq;
logiq = phys;
phys = temp;
Setscreen(loqiq,phys,-1);
}

/*-------------------------*/
/* rebond sur bande gauche */
/*-------------------------*/

g_rebon(n)
int n;
{
double cx,cy;
double cm,co;
if (mvt[n]==1) vit_glis(n);/* calcul de nouvelle vitesse */
else vit_roul(n);
fc = 1;
cx = -cr*vgx[n];
cm = vgy[n] -r*oz[n];

*/Ligne en partie effacee*/
if (cm != 0.0) cm = ((cm > 0.0) ? -1.0 : 1.0);

cy = vgy[n]-cm*fb*vgx[n]*(1.0+cr);
co = oz[n] + 2.5*cm*fb*vgx[n]*(1.0+cr)/(r*m);
if( (vgy[n]-r*oz[n])*(cy-r*co) <= 0)
{ cy = (5.0*vgy[n] + 2.0*r*oz[n])/7.0;
co =  cy / r;
}
vgx[n] = cx; vgy[n] = cy;
oz[n] = co; oy[n] = 0.0;
mvt[n] = 3;
}

/*-------------------------*/
/* rebond sur bande droite */
/*-------------------------*/
d_rebon(n)
int n;
{
double cx,cy;
double cm,co;

if (mvt[n]==1)vit_glis(n);
else vit_roul(n) ;
fc =2;
cx = -cr*vgx[n]
cm = vgy[n] + r*oz[n];
if (cm != 0.0) cm = ((cm > 0.0) ? -1.0 : 1.0);
cy = vgy[n] + cm * fb * vgx[n] * (1.0+cr);
co = oz[n] + 2.5 * cm * fb * vgx[n] * (1.0+cr)/(r*m);

if((vgy[n]+r*oz[n])*(cy+r*co) <= 0.0)
{ cy = (5.0 * vgy[n] - 2.0*r*oz[n])/7.0;
co = -cy/r;
}
vqx[n] = cx; vgy[n] = cy;
oz[n] = co; oy[n] = 0.0;
mvt[n] = 3;
}

/*-------------------*/
/* rebond bande haut */
/*-------------------*/
h_rebon(n)
int n;
{
double cy,cx;
double cm,co;
if(mvt[n] == 1) vit_glis(n);
else vit_roul(n);
fc = 3;
cy = -cr*vgy[n];
cm = vgx[n] + r*oz[n];
if(cm != 0.0) cm = ((cm > 0.0) ? -1.0: 1.0);
cx = vgx[n] - cm * fb * vgy[n] * (1.0+cr);
co = oz[n] - 2.5 * cm * fb * vgy[n] * (1.0+cr)/(r*m);

if((vqx[n]+r*oz[n])*(cx+r*co) <= 0.0)
{ cx = (5.0 * vgx[n] - 2.0 * r * oz[n])/7.0;
co = -cx/r;
}
vgx[n] = cx; vgy[n] = cy;
oz[n] = co; ox[n] = 0.0;
mvt[n] = 3;
}

/*---------------------*/
/* rebond bande du bas */
/*---------------------*/
b_rebon(n)
int n;
{
double cx,cy;
double cm,co;

if(mvt[n]==1) vit_glis(n);
else vit roul(n);
fc = 4;
cy = -cr*vgy[n];
cm = vgx(n) - r * oz[n];
if(cm != 0.0) cm = ((cm > 0.0) ? -1.0 : 1.0);
cx = vgx[n] + cm * fb * vgy[n] * (1.0+cr);
co = oz[n] - 2.5 * cm * fb * vgy[n]*(1.0+cr)/(r*m);

if((vgx[n]-r*oz[n])*(cx-r*co) <= 0.0)
{ cx = (5.0 * vgx[n] + 2.0 * r * oz[n])/7.0;
co = cx/r;
}
vgx[n] = cx; vgy[n] = cy;
oz[n] = co; ox[n] = 0.0;
mvt[n] = 3;
}

/*---------------------*/
/* choc de deux boules */
/* --------------------*/
choc(k,1)
int k,i;
{ double d;
  double cm;
if(k == cJoueur || i == cjoueur )
{ if (cjoueur == 0){ chc |= k; chc |= 1;}
else if (k == 0 || i == 0) chc |= 1;
else chc |= 2;
}
fc = 4+i+k;
if(mvt[k]==1) vit_glis(k);
else vit_roul(k);
if(mvt[i]==1) vit_glis(i);
else vit_roul(i);
dx = xb[k]-xb[i]; dy = yb[k]-yb[i];
d = sgrt(dx*dx+dy*dy);
ux[k] = dx/d;
uy[k] = dy/d;
cm = ux[k]*(vgx[k]-vgx[i]) + uy[k]*(vgy[k]-vgy[i]);
vgx[k] = -cm * ux[k] + vgx[k];
vgy[k] = -cm * uy[k] + vgy[k];
vgx[i] =  cm * ux[k] + vgx[i];
vgy[i] =  cm * uy[k] + vgy[i];
mvt[i] = 3; mvt[k] = 3;

/*------------------------------*/
/* vitesses cas sans glissement */
/*------------------------------*/
vit roul(j)
int j;
{
vgx[j] -= fr * r * (t-t0[j])*ux[j];
vgy[j] -= fr * r * (t-t0[j])*uy[j];
ox[j] = -vgy[j]/r;
oy[j] = vgx[j]/r;
}

/*------------------------------*/
/* vitesses cas avec glissement */
/*------------------------------*/
vit_glis(j)
int j;
{
vgx[j] -= g * f * (t-t0[j])*ux[j];
vgy[j] -= g * f * (t-t0[j])*uy[j];
ox[j] -= 2.5 * g * f * (t-t0[j])*uy[j]/(r*m);
oy[j] += 2.5 * g * f * (t-t0[j])*ux[j]/(r*m);
}

/*-----------------------*/
/* implantation du DECOR */
/*-----------------------*/
decor()
{
vsf_color(handle,1);
vsf_style(handle,2);
vsf_interior(handle,2);
cls(0,0,xreso,yreso);
if(xreso>500)
{ xcps = 57;
v_gtext(handle,xcps,gl_hchar," SCORE 1 ");
v_gtext(handle,xcps-56,2*gl_hchar,"COUPS 00  00  ");
v_gtext(handle,xcps-56,3*gl_hchar,"POINTS00  00  ");
else
{ xcps = 25;
v_gtext(handle,xcps,gl_hchar,"SCORE 1");
v_gtext(handle,1,2*gl_hchar,"CPS 0000");
v_gtext(handle,1,3*gl_hchar,"PTS 0000");
}
v_gtext(handle,1,4*gl_hchar,"FORCE :");
vsl_color(handle,0); vsl_width(handle,4);
pxy[0] = 34; pxy[1]= 4*gl_hchar+4; pxy[2]= xcl-rl; pxy[3] = pxy[1];
v_pline(handle,2,pxy);
vsl_width(handle,1);
vsf color(handle,1);
vsf_intertor(handle,1);
v_circle(handle,xcl,ycl,rl);
vsl_color(handle,1);
pxy[0]=xcl-rl; pxy[1]=ycl+rl; pxy[2]=pxy[0]+2*rl; pxy[3]=pxy[1];
v_pline(handle,2,pxy);
if (xreso >500) xopt = 410;
else xopt = 188;
v_gtext(handle,xopt,2*gl_hchar," 1 JOUEUR ");
v_gtext(handle,xopt,4*gl_hchar," MODIFIER ");
v_gtext(handle,xopt+88,4*gl_hchar,"QUIT");
billard(lx,ly);
vsm_type(handle,4);
}

billard(w,h)
int w,h;
{
vsf_perimeter(handle,0);
pxy[0]=34; pxy[1]=yreso/5+8; pxy[2]=pxy[0]+31+w;
pxy[3]= pxy[1]+31+h;
v_bar(handle,pxy);
vsf_color(handle,3);
vsf_style(handle,2);
vsf_interior(handle,3);
pxy[0]=42; pxy[1]=yreso/5+16; pxy[2]=pxy[0]+15+w;
pxy[3]=pxy[1]+15+h;
v_bar(handle,pxy);
vsf_color(handle,3);
vsf_interior(handle,1);
pxy[0]=tx0; pxy[1]=ty0; pxy[2]=tx0+w-1; pxy[3]=ty0+h-1;
v_bar(handle,pxy);
vsf_color(handle,1);
}
